/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

import kotlin.jvm.JvmOverloads
import com.herumi.mcl.MclJNI
import kotlin.jvm.Synchronized
import com.herumi.mcl.Fp
import com.herumi.mcl.Fr
import com.herumi.mcl.G1
import com.herumi.mcl.G2
import com.herumi.mcl.GT
import com.herumi.mcl.MclConstants
import com.herumi.mcl.SWIGTYPE_p_bool
import com.herumi.mcl.ElgamalJNI
import com.herumi.mcl.CipherText

object Elgamal {
    fun new_p_bool(): SWIGTYPE_p_bool? {
        val cPtr = ElgamalJNI.new_p_bool()
        return if (cPtr == 0L) null else SWIGTYPE_p_bool(cPtr, false)
    }

    fun copy_p_bool(value: Boolean): SWIGTYPE_p_bool? {
        val cPtr = ElgamalJNI.copy_p_bool(value)
        return if (cPtr == 0L) null else SWIGTYPE_p_bool(cPtr, false)
    }

    fun delete_p_bool(obj: SWIGTYPE_p_bool?) {
        ElgamalJNI.delete_p_bool(SWIGTYPE_p_bool.getCPtr(obj))
    }

    fun p_bool_assign(obj: SWIGTYPE_p_bool?, value: Boolean) {
        ElgamalJNI.p_bool_assign(SWIGTYPE_p_bool.getCPtr(obj), value)
    }

    fun p_bool_value(obj: SWIGTYPE_p_bool?): Boolean {
        return ElgamalJNI.p_bool_value(SWIGTYPE_p_bool.getCPtr(obj))
    }

    fun SystemInit(param: String?) {
        ElgamalJNI.SystemInit(param)
    }
}